/* $Id$ */

/** swig interface file for module image.
 *
 * \file image.i
 * \ingroup image
 */      

%module(directors="1") image

%{
/* ruby defines ALLOC which conflicts with boost */ 
#undef ALLOC
  
/* 
   * headers necessary to compile the wrapper
   */

#include "jafarConfig.h"
#include "image/Image.hpp"
#include "image/pyramid.hpp"
#include "image/lkTracker.hpp"
#include "image/ImagePreprocessor.hpp"
#include "jmath/jblas.hpp"
#include "image/roi.hpp"

using namespace jafar::image;

%}

%include "jafar.i"
%include "imageException.i"

%include "cxtypes.i"
%include "cxcore.i"
%include "cv.i"
%include "CvImage.i"
%include "CvCapture.i"
%include "jblas.i"

%include "image/cImage.h"

#if defined(SWIGRUBY)
%newobject jafar::image::Image::resize;
%newobject jafar::image::Image::rankTransform;
%newobject jafar::image::Image::loadImage;
#endif

%include "image/Image.hpp"
%rename(get) jafar::image::Pyramid::operator[];
%include "image/pyramid.hpp"
%include "image/lkTracker.hpp"
%include "image/roi.hpp"

%feature("director") jafar::image::ImagePreprocessorNode;
%include "image/ImagePreprocessor.hpp"

/* add basic function to Image class */

    %extend jafar::image::Image {
       short getPixelValueShort(int x, int y, int c = 0 )
       {
         return self->getPixelValue<short>(x, y, c );
       }
       double getSubPixelValueShort(double x, double y, int c = 0, JfrImage_InterpolationType _interpolation = JfrImage_INTERP_BILINEAR)
       {
         return self->getSubPixelValue<short>(x, y, c , _interpolation );
       }
       double getSubPixelValueFloat(double x, double y, int c = 0, JfrImage_InterpolationType _interpolation = JfrImage_INTERP_BILINEAR)
       {
         return self->getSubPixelValue<float>(x, y, c , _interpolation );
       }
      /* copy image
       * @param dst destination image
       */
/*        inline void copy(jafar::image::Image & dst) const { */
/*  	cvCopy(*self,dst); */
/*        }; */
};


%include "imageTools.i"

%init %{
	jafar::image::ImageException::enableOpenC_VException();
%}
// instantiate some print functions
%template(print) jafar::image::print<jafar::image::Image>;

// instantiate some getvalue
%template(getPixelValue8) jafar::image::Image::getPixelValue<unsigned char>;

