/* $Id$ */

/** Tools for module image.
 *
 * \file imageTools.i
 * \ingroup image
 */   

%{

#include <sstream>
#include <opencv/cxcore.h>
#if CV_MAJOR_VERSION*10 + CV_MINOR_VERSION > 21
#include <opencv2/highgui/highgui_c.h>
#else
#include <highgui.h> // opencv
#endif
#include "image/Image.hpp"

%}

%inline %{

namespace jafar {
  namespace image {


    /** Template print function which calls the output operator<< of A
     * and returns the resulting string.
     */
    template<class A>
    std::string print(const A& a_) {
      std::ostringstream os;
      os << a_ << std::endl;
      return os.str();
    };
    void extractImageRotTranslation(jafar::image::Image const& imagesrc, jafar::image::Image& imagedst, double u, double v, double angle)
    {
        float ca = cos(angle);
        float sa = sin(angle);
        float m[6] = { ca, sa, u, -sa, ca, v };
	cv::Mat M = cv::Mat( 2, 3, CV_32FC1, m );
        getQuadrangleSubPix( imagesrc, imagedst, M);

    }
  } // namespace image
} // namespace jafar

%}


