// boost unit test includes
#include <boost/test/auto_unit_test.hpp>

// jafar debug include
#include "kernel/jafarDebug.hpp"
#include "kernel/jafarTestMacro.hpp"
#include <fstream>

#include <iostream>
#include "image/Image.hpp"

using namespace std;
using namespace jafar;




BOOST_AUTO_TEST_CASE( test_image )
{
	image::Image img;
	img.load(std::string("data/corner.png"), 0);
	
	image::Image img1(5, 5, CV_8U, JfrImage_CS_GRAY);
	img.rotateScale(90., 1., img1);
	img1.save("data/test_corner1.png");

	image::Image img2(10, 10, CV_8U, JfrImage_CS_GRAY);
	img.rotateScale(90., 2., img2);
	img2.save("data/test_corner2.png");
	
	image::Image img2b(12, 12, CV_8U, JfrImage_CS_GRAY);
	img.rotateScale(90., 2., img2b);
	img2b.save("data/test_corner2b.png");
	
	
	image::Image img3(9, 9, CV_8U, JfrImage_CS_GRAY);
	img.rotateScale(90., 2., img3);
	img3.save("data/test_corner3.png");
	
	image::Image img4(5, 5, CV_8U, JfrImage_CS_GRAY);
	img3.rotateScale(-90., 1./2., img4);
	img4.save("data/test_corner4.png");
}


